{*******************************************************************************
  HiAsm stamp component builder v0.8 (autor - andrestudio <andrestudio@list.ru>)
  Component - VolumeControl
  Version - 1.0
  Autor - andrestudio
  E-mail - andrestudio72@yandex.ru
  Create - , 22.  2016, 21:01:31
  Description:     (free TAudioVolume)  KOL
   VCL  AudioVolume Silhwan Hyun  (hyunsh@hanafos.com)
*******************************************************************************}

unit hiVolumeControl;

interface

uses
  Windows, Kol, Share,
  debug, AudioVolumeKol;


type

 THIVolumeControl = class(TDebug)
   private

   { Property variable  }
     {     onProgressMaster  onProgressApp }
     fProgress: boolean;
     fMacterIdx: integer;
     fTimer: PTimer;
     fAudioVolume: TAudioVolume;
     fMuteMaster: boolean;
     fMuteApp: boolean;
     fOrientation: byte;

     fHandleTrackBarMaster: HWND;
     fHandleCheckBoxMaster: HWND;
     fHandleProgressBarMaster: HWND;
     fHandleTrackBarApp: HWND;
     fHandleCheckBoxApp: HWND;
     fHandleProgressBarApp: HWND;
     fHandleLBCB: HWND;

     fTrackBarMaster: PControl;
     fCheckBoxMaster: PControl;
     fProgressBarMaster: PControl;
     fTrackBarApp: PControl;
     fCheckBoxApp: PControl;
     fProgressBarApp: PControl;
     fLBCB: PControl;

     OldTrackBarMasterMsg: TOnMessage;
     OldTrackBarAppMsg: TOnMessage;
     OldCheckBoxMasterMsg: TOnMessage;
     OldCheckBoxAppMsg: TOnMessage;

     procedure SetKind(Value: byte);
     procedure OnProgress(Obj: PObj);
     function _onMessageTrackBarMaster( var Msg: TMsg; var Rslt: Integer ): Boolean;
     function _onMessageTrackBarApp( var Msg: TMsg; var Rslt: Integer ): Boolean;
     function _onMessageCheckBoxMaster( var Msg: TMsg; var Rslt: Integer ): Boolean;
     function _onMessageCheckBoxApp( var Msg: TMsg; var Rslt: Integer ): Boolean;

   public
   { Event points }
     {      doGetDevices    
          }
     _event_onDevices: THI_Event;
     {        
     MasterIdx (0-100) }
     _event_onProgressMaster: THI_Event;
     {       (0-100) }
     _event_onProgressApp: THI_Event;
     {        1 
         ,  0 }
     _event_onCheckMuteMaster: THI_Event;
     {        1 
       ,  0}
     _event_onCheckMuteApp: THI_Event;
     {        
     (0-100)      IdxMaster }
     _event_onPositionMaster: THI_Event;
     {        
     (0-100)   }
     _event_onPositionApp: THI_Event;
     {   }
     _event_onError: THI_Event;

   { Data points}
     {     doMasterVolume }
     _data_MasterIdx: THI_Event;
     _data_HandleTrackBarMaster: THI_Event;
     _data_HandleCheckBoxMaster: THI_Event;
     _data_HandleTrackBarApp: THI_Event;
     _data_HandleCheckBoxApp: THI_Event;
     _data_HandleProgressBarMaster: THI_Event;
     _data_HandleProgressBarApp: THI_Event;

     //_data_HandleLBCB: THI_Event;

     constructor Create;
     destructor Destroy; override;
     procedure Init;
   { Events }
     {         
      .      (0-100) }
     procedure onMasterVolumeEvent(ByMyAction: Boolean;
                 Volume: Single; Mute: Boolean);
     {        
      .     (0-100) }
     procedure onAppVolumeEvent(ByMyAction: Boolean;
                 Volume: Single; Mute: Boolean);
     {     (ENG) }
     procedure onErr(Err: string);

   { Methods }
     {         
      onDevices }
     procedure _work_doGetDevices(var _Data: TData; Index: Word);
     {         
        MasterIdx }
     procedure _work_doSelectMaster(var _Data: TData; Index: Word);
     {     (1-100)   
      MasterIdx.       0 }
     procedure _work_doMasterVolume(var _Data: TData; Index: Word);
     {     (0-100) }
     procedure _work_doAppVolume(var _Data: TData; Index: Word);
     { -0, -1      
     MasterIdx }
     procedure _work_doMasterMute(var _Data: TData; Index: Word);
     { -0, -1   . }
     procedure _work_doAppMute(var _Data: TData; Index: Word);

     function ReadControlEx(PointData: THI_Event): PControl;

   { Property }
     {     onProgressMaster  onProgressApp }
     property _prop_Progress: boolean  read fProgress  write fProgress;
     {  TrackBar()   }
     property _prop_Kind: byte write SetKind;
  end;

implementation

uses
  Messages;

const
  TBM_GETPOS  = WM_USER;
  TBM_SETPOS  = WM_USER+5;

function WideStringToString(const ws: WideString): string;
var
  l: integer;
const
  codePage = 3;
begin
  if ws = '' then
    Result := ''
else
  begin
    l := WideCharToMultiByte(codePage,
      WC_COMPOSITECHECK or WC_DISCARDNS or WC_SEPCHARS or WC_DEFAULTCHAR,
      @ws[1], -1, nil, 0, nil, nil);
    SetLength(Result, l - 1);
    if l > 1 then
      WideCharToMultiByte(codePage,
        WC_COMPOSITECHECK or WC_DISCARDNS or WC_SEPCHARS or WC_DEFAULTCHAR,
        @ws[1], -1, @Result[1], l - 1, nil, nil);
  end;
end;

procedure THIVolumeControl.SetKind(Value: byte);
begin
  fOrientation := Value;
end;

function THIVolumeControl._onMessageTrackBarMaster;
var
  Pos: integer;
begin
  case Msg.message of
    WM_PAINT:
      begin
        if Assigned(fAudioVolume) then
        begin
          Pos := SendMessage(fHandleTrackBarMaster,TBM_GETPOS,0,0);
          case fOrientation of
            0: fAudioVolume.SetMasterVolume((Pos) / 100);
            1: fAudioVolume.SetMasterVolume((100 - (Pos)) / 100);
          end;
        end;
      end;
  end;
  Result := _hi_OnMessage(OldTrackBarMasterMsg,Msg,Rslt);
end;

function THIVolumeControl._onMessageTrackBarApp;
var
  Pos: integer;
begin
  case Msg.message of
    WM_PAINT:
      begin
        if Assigned(fAudioVolume) then
        begin
          Pos := SendMessage(fHandleTrackBarApp,TBM_GETPOS,0,0);
          case fOrientation of
            0: fAudioVolume.SetVolume((Pos) / 100);
            1: fAudioVolume.SetVolume((100 - (Pos)) / 100);
          end;
        end;
      end;
  end;
  Result := _hi_OnMessage(OldTrackBarAppMsg,Msg,Rslt);
end;

function THIVolumeControl._onMessageCheckBoxMaster;
begin
  case Msg.message of
    WM_LBUTTONUP,WM_KEYUP:
      begin
        if Assigned(fAudioVolume) then
          fAudioVolume.SetMasterMute(not fCheckBoxMaster.Checked);
      end;
  end;
  Result := _hi_OnMessage(OldCheckBoxMasterMsg,Msg,Rslt);
end;

function THIVolumeControl._onMessageCheckBoxApp;
begin
  case Msg.message of
    WM_LBUTTONUP,WM_KEYUP:
      begin
        if Assigned(fAudioVolume) then
          fAudioVolume.SetMute(not fCheckBoxApp.Checked);
      end;
  end;
  Result := _hi_OnMessage(OldCheckBoxAppMsg,Msg,Rslt);
end;



constructor THIVolumeControl.Create;
begin
  inherited Create;

  InitAdd(Init);
end;

destructor THIVolumeControl.Destroy;
begin
  fTimer.Free;
  inherited
end;

function THIVolumeControl.ReadControlEx;
var dt:TData;
begin
  dt.Data_type := data_null;
  _ReadData(dt,PointData);
  if( Dt.Data_type = data_int)then
   Result := PControl(dt.idata)
  else Result := nil;
end;

function GetPControl(AHWND: HWND): PControl;
const
  ID_SELF: array[ 0..5 ] of Char = ( 'S','E','L','F','_',#0 );
begin
  Result := Pointer(GetProp(AHWND, ID_SELF));
end;

procedure THIVolumeControl.OnProgress;
var
  MasterMeter,AppMeter: integer;
begin
  MasterMeter := Round(fAudioVolume.GetMasterPeak * 100.0);
  AppMeter := Round(fAudioVolume.GetPeak * 100.0);
  _hi_onEvent(_event_onProgressMaster, MasterMeter);
  _hi_onEvent(_event_onProgressApp, AppMeter);
  if Assigned(fProgressBarMaster) then
   fProgressBarMaster.Progress := MasterMeter;
  if Assigned(fProgressBarApp) then
   fProgressBarApp.Progress := AppMeter;
end;

procedure THIVolumeControl.Init;
var
  i: integer;
  PositionMaster: integer;
  PositionApp: integer;
begin
  fAudioVolume := TAudioVolume.Create(self);
  fAudioVolume.SuppressEvent := False;
  fAudioVolume.OnMasterVolumeEvent := onMasterVolumeEvent;
  fAudioVolume.OnVolumeEvent := onAppVolumeEvent;
  fAudioVolume.OnError := onErr;

  fHandleTrackBarMaster := ToIntegerEvent(_data_HandleTrackBarMaster);
  if fHandleTrackBarMaster <> 0 then
  begin
    fTrackBarMaster := GetPControl(fHandleTrackBarMaster);
    OldTrackBarMasterMsg := fTrackBarMaster.OnMessage;
    fTrackBarMaster.OnMessage := _onMessageTrackBarMaster;
  end;

  fHandleTrackBarApp := ToIntegerEvent(_data_HandleTrackBarApp);
  if fHandleTrackBarApp <> 0 then
  begin
    fTrackBarApp := GetPControl(fHandleTrackBarApp);
    OldTrackBarAppMsg := fTrackBarApp.OnMessage;
    fTrackBarApp.OnMessage := _onMessageTrackBarApp;
  end;

  fHandleCheckBoxMaster := ToIntegerEvent(_data_HandleCheckBoxMaster);
  if fHandleCheckBoxMaster <> 0 then
  begin
    fCheckBoxMaster := GetPControl(fHandleCheckBoxMaster);
    OldCheckBoxMasterMsg := fCheckBoxMaster.OnMessage;
    fCheckBoxMaster.OnMessage := _onMessageCheckBoxMaster;
  end;

  fHandleCheckBoxApp := ToIntegerEvent(_data_HandleCheckBoxApp);
  if fHandleCheckBoxApp <> 0 then
  begin
    fCheckBoxApp := GetPControl(fHandleCheckBoxApp);
    OldCheckBoxAppMsg := fCheckBoxApp.OnMessage;
    fCheckBoxApp.OnMessage := _onMessageCheckBoxApp;
  end;

  fHandleProgressBarMaster := ToIntegerEvent(_data_HandleProgressBarMaster);
  if fHandleProgressBarMaster <> 0 then
    fProgressBarMaster := GetPControl(fHandleProgressBarMaster);

  fHandleProgressBarApp := ToIntegerEvent(_data_HandleProgressBarApp);
  if fHandleProgressBarApp <> 0 then
    fProgressBarApp := GetPControl(fHandleProgressBarApp);

  if _prop_Progress then
  begin
    fTimer := NewTimer(50);
    fTimer.OnTimer := onProgress;
    fTimer.Enabled := True;
    fAudioVolume.SetupPeakMeter;
  end;

  for i := 0 to fAudioVolume.AudioDeviceCount - 1 do
    _hi_onEvent(_event_onDevices, WideStringToString(fAudioVolume.AudioDeviceInfo(i).DeviceName));

  fMacterIdx := ToIntegerEvent( _data_MasterIdx );

  if ( fAudioVolume.AudioDeviceCount > 0 ) and ( fMacterIdx = -1 ) then
    fAudioVolume.SelectAudioDevice(0)
  else fAudioVolume.SelectAudioDevice(fMacterIdx);

  case fOrientation of
    0: begin
         PositionMaster := Round((fAudioVolume.GetMasterVolume) * 100);
         PositionApp := Round((fAudioVolume.GetVolume) * 100);
       end;
    1: begin
         PositionMaster := Round((1.0 - fAudioVolume.GetMasterVolume) * 100);
         PositionApp := Round((1.0 - fAudioVolume.GetVolume) * 100);
       end;
   end;

  _hi_onEvent(_event_onPositionMaster, PositionMaster);
  _hi_onEvent(_event_onPositionApp, PositionApp);

  if fHandleTrackBarMaster <> 0 then
    SendMessage(fHandleTrackBarMaster, TBM_SETPOS, 1, PositionMaster);

  if fHandleTrackBarApp <> 0 then
    SendMessage(fHandleTrackBarApp, TBM_SETPOS, 1, PositionApp);

  if not fAudioVolume.IsMasterMuted then
    begin
      _hi_onEvent(_event_onCheckMuteMaster, 0);
      fMuteMaster := False;
      if Assigned(fCheckBoxMaster) then
        fCheckBoxMaster.Checked := False;
    end
  else
    begin
      _hi_onEvent(_event_onCheckMuteMaster, 1);
      fMuteMaster := True;
      _hi_onEvent(_event_onCheckMuteApp, 1);
      fMuteApp := True;
      if Assigned(fCheckBoxMaster) then
        fCheckBoxMaster.Checked := True;
      if Assigned(fCheckBoxApp) then
        fCheckBoxApp.Checked := True;
      Exit; // !!!
    end;

  if not fAudioVolume.IsMuted then
    begin
      _hi_onEvent(_event_onCheckMuteApp, 0);
      fMuteApp := False;
      if Assigned(fCheckBoxApp) then
        fCheckBoxApp.Checked := False;
    end
  else
    begin
      _hi_onEvent(_event_onCheckMuteApp, 1);
      fMuteApp := True;
      if Assigned(fCheckBoxApp) then
        fCheckBoxApp.Checked := True;
    end;


  //inherited
end;

{     (ENG) }
procedure THIVolumeControl.onErr(Err: string);
begin
  _hi_onEvent(_event_onError, Err);
end;

{          
.      (0-100) }
procedure THIVolumeControl.onMasterVolumeEvent;
var
  NewPosition: integer;
begin
  if ByMyAction then exit;

  case fOrientation of
    0: NewPosition := Round((Volume) * 100);
    1: NewPosition := Round((1.0 - (Volume)) * 100);
  end;

  _hi_onEvent(_event_onPositionMaster, NewPosition);
  if Mute <> fMuteMaster then
    begin
      _hi_onEvent(_event_onCheckMuteMaster, Integer(Mute));
      fMuteMaster := Mute;

      if Assigned(fCheckBoxMaster) then
        fCheckBoxMaster.Checked := Mute;

      if Mute then
        begin
          _hi_onEvent(_event_onCheckMuteApp, Integer(Mute));
          if Assigned(fCheckBoxApp) then
            fCheckBoxApp.Checked := Mute;
        end
      else
        begin
          _hi_onEvent(_event_onCheckMuteApp, Integer(fMuteApp));
          if Assigned(fCheckBoxApp) then
            fCheckBoxApp.Checked := fMuteApp;
        end;
    end;

  if Assigned(fTrackBarMaster) then
  begin
    SendMessage(fTrackBarMaster.Handle, TBM_SETPOS, 1, NewPosition);
  end;

end;

{         
.     (0-100) }
procedure THIVolumeControl.onAppVolumeEvent;
var
  NewPosition: integer;
begin
  if ByMyAction then exit;
  case fOrientation of
    0: NewPosition := Round((Volume) * 100);
    1: NewPosition := Round((1.0 - (Volume)) * 100);
  end;
  _hi_onEvent(_event_onPositionApp, NewPosition);
  if Mute <> fMuteApp then
    begin
      _hi_onEvent(_event_onCheckMuteApp, Integer(Mute));
      fMuteApp := Mute;
      if Assigned(fCheckBoxApp) then
        fCheckBoxApp.Checked := Mute;
    end;

  if Assigned(fTrackBarApp) then
  begin
    SendMessage(fHandleTrackBarApp, TBM_SETPOS, 1, NewPosition);
  end;
end;

{          
onDevices }
procedure THIVolumeControl._work_doGetDevices;
var
  i: integer;
begin
  if Assigned(fAudioVolume) then
    for i := 0 to fAudioVolume.AudioDeviceCount - 1 do
      _hi_onEvent(_event_onDevices, WideStringToString(fAudioVolume.AudioDeviceInfo(i).DeviceName));

end;

{           
 MasterIdx }
procedure THIVolumeControl._work_doSelectMaster;
begin
  if Assigned(fAudioVolume) then
    fAudioVolume.SelectAudioDevice(ToIntegerEvent(_data_MasterIdx));
  Applet.ProcessMessages;
end;

{     (1-100)    
MasterIdx.       0 }
procedure THIVolumeControl._work_doMasterVolume;
begin
  if Assigned(fAudioVolume) then
    fAudioVolume.SetMasterVolume((ToInteger(_Data)) / 100);
end;

{     (0-100) }
procedure THIVolumeControl._work_doAppVolume;
begin
  if Assigned(fAudioVolume) then
    fAudioVolume.SetVolume((ToInteger(_Data)) / 100);
end;

{ -0, -1       MasterIdx }
procedure THIVolumeControl._work_doMasterMute;
begin
  if Assigned(fAudioVolume) then
    fAudioVolume.SetMasterMute(boolean(ToInteger(_Data)));
end;

{ -0, -1   . }
procedure THIVolumeControl._work_doAppMute;
begin
  if Assigned(fAudioVolume) then
    fAudioVolume.SetMute(boolean(ToInteger(_Data)));
end;

initialization

end.
